import "./style.css";
import { reactive as N, ref as D, watchEffect as j, onActivated as B, nextTick as x, onBeforeUnmount as F, resolveComponent as h, openBlock as T, createElementBlock as P, createElementVNode as l, createVNode as v, withCtx as W, withDirectives as A, vShow as J } from "vue";
import { Button as O } from "@opentiny/vue";
import { VueMonaco as U, CloseIcon as V, LinkButton as H } from "@opentiny/tiny-engine-common";
import { useCanvas as g, useNotify as y, useModal as E, useHelp as I } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as z } from "@opentiny/tiny-engine-common/js/completion";
import { lint as R, initLinter as Y } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as q, string2Ast as b, formatString as G, ast2String as K } from "@opentiny/tiny-engine-common/js/ast";
import { constants as Q } from "@opentiny/tiny-engine-utils";
import { isFunction as X } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: k } = Q, r = N({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = D(null);
let _ = null;
const C = () => {
  var t, n;
  const o = ((n = (t = g()).getSchema) == null ? void 0 : n.call(t)) || {};
  return o.methods = (o == null ? void 0 : o.methods) || {}, o.methods;
}, Z = () => g().pageState.pageSchema && Object.keys(C()) || [], M = () => {
  const t = Object.entries(C()).map(([n, e]) => q(n, e.value)).join(`
`);
  try {
    _ = b(t);
  } catch (n) {
    y({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return t;
}, $ = (o) => {
  if (r.isChanged = o !== r.script, !a.value)
    return;
  const t = a.value.getEditor().getModel();
  R(t, r.linterWorker);
}, tt = ({ name: o, content: t }) => {
  if (!o)
    return;
  const n = C(), e = {
    type: k.JSFunction,
    value: t
  };
  g().updateSchema({ methods: { ...n, [o]: e } });
}, w = () => {
  const { message: o } = E();
  if (!r.isChanged)
    return !1;
  if (r.hasError)
    return o({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const t = a.value.getEditor().getValue(), n = b(t), e = {};
  return n.program.body.forEach((s, i) => {
    var m, u;
    const d = (m = s == null ? void 0 : s.id) == null ? void 0 : m.name;
    (u = n.program.body[i + 1]) != null && u.leadingComments && s.trailingComments === n.program.body[i + 1].leadingComments && delete s.trailingComments;
    const p = G(K(s).trim(), "javascript");
    d && (e[d] = {
      type: k.JSFunction,
      value: p
    });
  }), g().updateSchema({ methods: e }), g().setSaved(!1), r.isChanged = !1, y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, et = (o) => (t) => {
  const { confirm: n } = E(), e = X(t) ? t : () => o("close");
  if (!r.isChanged) {
    e(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      e(w());
    },
    cancel() {
      e(!0);
    }
  });
}, ot = () => {
  if (!r.editorSelection || !a.value)
    return;
  const o = a.value.getEditor();
  o.setSelection(r.editorSelection), o.focus();
  const t = o.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  o.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: t
    },
    0
  );
}, nt = (o) => {
  var e;
  if (!o)
    return;
  const t = _ == null ? void 0 : _.program.body.filter((s) => {
    var i;
    return o === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (t.length === 0)
    return;
  const n = (e = t[0]) == null ? void 0 : e.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && ot();
}, st = ({ emit: o }) => (j(() => {
  r.script = M();
}), B(() => {
  x(() => {
    var t;
    r.script = M(), (t = a.value) == null || t.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: a,
  change: $,
  saveMethods: w,
  close: et(o)
}), rt = (o, t) => {
  const n = o.__vccOpts || o;
  for (const [e, s] of t)
    n[e] = s;
  return n;
}, it = {
  saveMethod: tt,
  highlightMethod: nt,
  getMethodNameList: Z,
  getMethods: C
}, ct = {
  components: {
    MonacoEditor: U,
    TinyButton: O,
    CloseIcon: V,
    LinkButton: H
  },
  emits: ["close"],
  setup(o, { emit: t }) {
    const n = I().getDocsUrl("script"), { state: e, monaco: s, change: i, close: d, saveMethods: p } = st({ emit: t }), m = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, u = (f) => {
      var c;
      s.value && (e.completionProvider = z(s.value.getMonaco(), (c = s.value.getEditor()) == null ? void 0 : c.getModel()), e.linterWorker = Y(f, s.value.getMonaco(), e));
    };
    return F(() => {
      var f, c, S;
      (f = e.completionProvider) == null || f.forEach((L) => {
        L.dispose();
      }), (S = (c = e.linterWorker) == null ? void 0 : c.terminate) == null || S.call(c);
    }), {
      state: e,
      monaco: s,
      options: m,
      close: d,
      change: i,
      saveMethods: p,
      editorDidMount: u,
      docsUrl: n
    };
  }
}, lt = { class: "plugin-page-js-container" }, at = { class: "code-edit-head" }, dt = { class: "head-left" }, mt = { class: "head-right" }, ut = { class: "dots" }, pt = { class: "code-edit-content" };
function gt(o, t, n, e, s, i) {
  const d = h("link-button"), p = h("tiny-button"), m = h("close-icon"), u = h("monaco-editor");
  return T(), P("div", lt, [
    l("div", at, [
      l("div", dt, [
        t[0] || (t[0] = l("span", { class: "title" }, "页面 JS", -1)),
        v(d, { href: e.docsUrl }, null, 8, ["href"])
      ]),
      l("div", mt, [
        v(p, {
          type: "primary",
          class: "save-btn",
          onClick: e.saveMethods
        }, {
          default: W(() => [
            t[1] || (t[1] = l("span", null, "保存", -1)),
            A(l("span", ut, null, 512), [
              [J, e.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        v(m, { onClose: e.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", pt, [
      v(u, {
        ref: "monaco",
        value: e.state.script,
        options: e.options,
        onChange: e.change,
        onEditorDidMount: e.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const ft = /* @__PURE__ */ rt(ct, [["render", gt], ["__scopeId", "data-v-f0071c66"]]), ht = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "top",
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, Lt = {
  ...ht,
  apis: it,
  entry: ft
};
export {
  Lt as default
};
